//--------------------------------------------------------------------------------------
// World/VOB-Pixelshader for G2D3D11 by Degenerated
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
// Textures and Samplers
//--------------------------------------------------------------------------------------
SamplerState SS_Linear : register( s0 );
SamplerState SS_samMirror : register( s1 );
Texture2D	TX_Scene : register( t0 );
Texture2D	TX_Lum : register( t1 );

cbuffer HDR_Settings : register(b0)
{
	float HDR_MiddleGray;
	float HDR_LumWhite;
	float HDR_Threshold;
};

//--------------------------------------------------------------------------------------
// Input / Output structures
//--------------------------------------------------------------------------------------
struct PS_INPUT
{
	float2 vTexcoord		: TEXCOORD0;
	float3 vEyeRay			: TEXCOORD1;
	float4 vPosition		: SV_POSITION;
};

static const float3 LUM_CONVERT = float3(0.299f, 0.587f, 0.114f); 

float3 ToneMap(float3 vColor)
{
	// Get the calculated average luminance
	float fLumAvg = TX_Lum.SampleLevel(SS_Linear, float2(0.5f, 0.5f), 10).r;

	// Calculate the luminance of the current pixel
	float fLumPixel = dot(vColor, LUM_CONVERT);
	
	vColor.rgb *= HDR_MiddleGray / (fLumAvg.r + 0.001f);
    vColor.rgb *= (1.0f + vColor/HDR_LumWhite);
    vColor.rgb /= (1.0f + vColor);

	return pow( vColor, 2.2f );
    return saturate( vColor );
} 

//--------------------------------------------------------------------------------------
// Pixel Shader
//--------------------------------------------------------------------------------------
float4 PSMain( PS_INPUT Input ) : SV_TARGET
{
	float4 sample = TX_Scene.Sample(SS_Linear, Input.vTexcoord);
	float3 HDRColor = sample.rgb;
	
	HDRColor -= HDR_Threshold;
	HDRColor = max(0, HDRColor);
	
	float3 toneMapped = HDRColor;//ToneMap(HDRColor);
	
	return float4(toneMapped.rgb, 1); 
}

